#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#define MENUKEY 0
#define LEFTKEY 125
#define RIGHTKEY 375
#define UPKEY 305
#define DOWNKEY 225
#define OKKEY 425
#define SCRADR 0x3F

#include <Eeprom24C04_16.h>
//#define BATT "Battery: "
#define CLEEN_LEFT "<               "
#define CLEAN_RIHGT "               >"
#define CLEAN_TOTAL "                "
#define LEFT_RIHGT "<              >"
#define TEST_SD "Test SD Card"
#define FILED "Failed!!! :("
#define SUCCESS "Success!"
#define SET_FW "Set. FW.:"
#define SET_MOD "Set. mod."
#define FW_WORK "Prog..."
#define ERROR_1 "Error 1"
#define ERROR_2 "Error 2"
#define BACK "Click back"
#define _HEX "HEX"
#define NO_CHIP "Chip not found!"
#define CRUM "CRUM"
#define PROBEL " "

#define MOD_CHIP "Mod. chip:"
#define __CXX "24cXX(SD Card)"



#define NO_FILE "File not support"
#define AUTO_OFF 2// время в минутах до авто-выключения питания при бездействии
#define LONG_PRESS_KEY 700 //время в милисекундах после которого считается что кнопка нажата в режиме "с удержанием"
LiquidCrystal_I2C lcd(SCRADR,16,2);  // set the LCD address to 0x27 for a 16 chars and 2 line display

#include <avr/pgmspace.h>

const int key_in = A0;//аналоговый вход для подключения аналоговой клавиатуры
const int chipSelect = 2;         // Пин к которому подсоединен вывод модуля CS (SD Card)
boolean key = 0;
int k;
//const int value_batt = A1;//вход для измерения уровня заряда  батареии
 
//const int power = A2; //пин управляющий включением питания
#include <SPI.h>    // Подключаем библиотеку для работы с SPI устройствами
#include <SD.h>     // Подключаем библиотеку для работы с SD картой
File root;

// Указываем пин подключения chipSelect (CS), в соответствии со схемой сборки, модулем или шилдом;
// Arduino Ethernet shield: pin 4
// Adafruit SD shields and modules: pin 10
// Sparkfun SD shield: pin 8

byte counts_folder = 0;
byte counts_folder_2 = 0;
byte counts_file = 0;
byte counts_file_2 =0; 
byte navigation = 0;//выбор кнопками влево, вправо
String set_file = "";
String name_folder = "/";
byte menu = 0;
//если menu = :
//            0 - меню батареии (процент заряда)
//            1 - меню выбора типа чипа (24сХХ или 921 и др.)
//            2 - выбор модели МФУ\ принтера для чипов 24сХХ
//            3 - выбор прошивки для чипов 24сХХ на SD Card
//            4 - процес прошивки для чипов 24сХХ с SD Card в чип
//            5 - выбор модэли/объема чипа 24Cxx
//            6 - процесс чтения дампа из чипа в файл на sd card
//            7 - меню "Чип инфо" 
//long update_batt = 0;
//long timer_out_power_off = 0;
long timer_long_press_key = 0;
//int procent = 0; //уровень заряда ботареи в процентах 
bool error = 0;
byte i2c_adrr = 0;
int value_EEPROM_Chip = 0;//объем чипа
int bufer_KX_MB1500;//буфер для хранения значения АЦП для тэстера чипов Panasonic KX-MB1500

void setup() {
//pinMode(power, OUTPUT);
//digitalWrite(power, HIGH);//Высокий уровень HIGH включает питание
pinMode(key_in, INPUT );
//pinMode(value_batt, INPUT);
pinMode(chipSelect, OUTPUT); 
lcd.init();                      // initialize the lcd 
lcd.backlight();
lcd.clear();
randomSeed(analogRead(A3));//иницилизируем генератор случайных чисел на неиспользуемом аналоговом порте
Serial.begin(115200);


Serial.print(F("Initializing SD card..."));

  if (!SD.begin(chipSelect)) {
    Serial.println(F("initialization failed!"));
      lcd.setCursor(2,0);
      lcd.print(TEST_SD);
      lcd.setCursor(4,1);
      lcd.print(FILED);
    return;
  }else{
      Serial.println(F("initialization done."));
      lcd.setCursor(2,0);
      lcd.print(TEST_SD);
      lcd.setCursor(4,1);
      lcd.print(SUCCESS);
  }

delay(1000);
//timer_out_power_off = millis();
//update_batt = millis();

}


void SD_card(File dir){
 
while (true){
  
 File myFolder = dir.openNextFile();
 //Serial.print(F("dir =  "));
//Serial.println(dir); 
//Serial.print(F("Folder name =  "));
//Serial.println(myFolder); 
  if (!myFolder) {      
      break;
    }
 if (myFolder.isDirectory() ) {//если это папка, т.е. "выбор модели"
      //Serial.println("/");
      counts_folder_2 = counts_folder_2 + 1; //то прибовляем к счетчику каличества папок
      //Serial.print (F("counts_folder_2:  "));
      //Serial.println(counts_folder_2);
      
      if(counts_folder_2 == navigation && menu == 2){
      lcd.clear();  
      lcd.setCursor(0,0);
      lcd.print(CLEAN_TOTAL);
      lcd.setCursor(2,0);
      lcd.print(SET_MOD);
      if(navigation == 1){
      lcd.setCursor(0,1);
      lcd.print(CLEAN_RIHGT);  
      }
      if(navigation == counts_folder){
      lcd.setCursor(0,1);
      lcd.print(CLEEN_LEFT);  
      }
      if(navigation > 1 && navigation < counts_folder){
      lcd.setCursor(0,1);
      lcd.print(LEFT_RIHGT);
      }
      lcd.setCursor(2,1);
      lcd.print(myFolder.name());
      name_folder = myFolder.name();
      Serial.print(F("Folder name =  "));
      Serial.println(myFolder.name()); 
 }
}
 
if(!myFolder.isDirectory() ){// если это файл т.е. выбор прошивки
 counts_file = counts_file + 1;// то прибовляем к количеству файлов
 if(counts_file == navigation && menu == 3){
  lcd.clear();
 lcd.setCursor(0,0);
 lcd.print(CLEAN_TOTAL);
 lcd.setCursor(1,0);
 lcd.print(SET_FW);
 
 if(navigation == 1){
 lcd.setCursor(0,1);
 lcd.print(CLEAN_RIHGT);  
 }
 if(navigation == counts_file_2 && counts_file > 1){
 lcd.setCursor(0,1);
 lcd.print(CLEEN_LEFT);  
 }
 if(navigation > 1 && navigation < counts_file_2){
 lcd.setCursor(0,1);
 lcd.print(LEFT_RIHGT);
 }
 lcd.setCursor(1,1);
 lcd.print(myFolder.name());
 set_file = myFolder.name();
 Serial.print(F("File name =  "));
 Serial.println(myFolder.name());     
 }
                    
}

  myFolder.close();
  
  
}
counts_folder = counts_folder_2;
counts_folder_2 = 0;
counts_file_2 = counts_file;
if(counts_file == 1){//если файлов в папке всего 1 
 lcd.setCursor(15,1);//то стираем пробелом вконце 2-ой строки стрелку вправо ("               >")
 lcd.print(PROBEL); 
}
counts_file = 0; 
//Serial.println(F("Sd_card done"));
}

/*
void batt(){
 procent = analogRead(value_batt);
  procent = map(procent, 613, 839, 0, 100);// где 613 значение АЦП для 3,0 вольт и 831 значение АЦП для 4,2 вольта
 
 if(procent < 1)digitalWrite(power, LOW); //выключаем питание
 lcd.setCursor(0,1);
 lcd.print(CLEAN_TOTAL);
 lcd.setCursor(0,0);
 lcd.print(CLEAN_TOTAL);
 lcd.setCursor(1,0);
 lcd.print(BATT); 
 lcd.setCursor(10,0);
 lcd.print(F("   "));
 lcd.setCursor(10,0);
 lcd.print(procent);
 lcd.setCursor(13,0);
 lcd.print("%"); 
}
*/
void i2c_scaner(){
//==========================================I2C СКАНЕР======================================
   i2c_adrr = 0;    
      byte error_scan;
  Wire.begin();
  Serial.println(F("Scan i2c start"));     
for( byte i = 1; i < 127; i ++){
 if(i!=SCRADR) {
 Wire.beginTransmission(i); 
 error_scan = Wire.endTransmission();
if(error_scan == 0){   
   i2c_adrr = i;
   
   break;// преривание for используем только 1-ый найденный i2c девайс 
} 
}
}



Serial.print(F("i2c_adrr = "));
Serial.println(i2c_adrr, HEX);
delay(10);
if(i2c_adrr != 0){
      lcd.clear();
      lcd.setCursor(0,0);
      lcd.print(CLEAN_TOTAL);
      lcd.setCursor(0,0);
      lcd.print(FW_WORK);
      lcd.setCursor(7,0);
      lcd.print(i2c_adrr, HEX);
      lcd.setCursor(9,0);
      lcd.print(_HEX);
      if(menu == 4){
      lcd.setCursor(0,1);
      lcd.print(CLEAN_TOTAL);
      lcd.setCursor(0,1);
      lcd.print(set_file);
      }
}else{
      lcd.clear();
      lcd.setCursor(0,0);
      lcd.print(CLEAN_TOTAL);
      lcd.setCursor(0,0);
      lcd.print(NO_CHIP);
      lcd.setCursor(0,1);
      lcd.print(CLEAN_TOTAL);
      lcd.setCursor(4,1);
      lcd.print(ERROR_2);
      error = 2;    
}


}


void program_Work(){
Serial.println(F("Prog start"));  
i2c_scaner(); 
if(i2c_adrr != 0)value_EEPROM();//функция определения объема чипа

//====определяем тип файла прошивки на sd card====================================
byte algoritm;
if(set_file.lastIndexOf(".E2P") != -1){//если файл с расширением .e2p 
 algoritm = 0;//то алгоритм равен 0
 Serial.println(F("Select file .e2p "));
}else if

(set_file.lastIndexOf(".BIN") != -1){//если файл с расширением .bin
 algoritm = 1;//то алгоритм равен 1
 Serial.println(F("Select file .bin "));
}else{
 error = 3;
 lcd.setCursor(0,0);
 lcd.print(CLEAN_TOTAL);
 lcd.setCursor(0,0);
 lcd.print(NO_FILE); 
}


if(i2c_adrr != 0 && error == 0){

//===========================установка адреса i2c==================================
Eeprom24C04_16 eeprom(i2c_adrr);
eeprom.initialize(); 


//=============================================================================
//=======переменые для поиска "CRUM-"(почти все Xer и Sams) или "y-","k-","m-","c-"(для xer 6100 или sams 510)==================
boolean crum_SP3600 = 0;

boolean no_crum = 0;// если = 0 то CRUM не найден в прошивке, если = 1, то найден!
byte search_crum = 1; // для поиска фразы "CRUM-"(почти все Xer и Sams) или "y-","k-","m-","c-"(для xer 6100 или sams 510)
byte crum[] = "00123456789"; //для подмены CRUM
byte i = 0;//  счетчик подмененных цифр CRUM
if((set_file.lastIndexOf("SP3600") != -1) || (set_file.lastIndexOf("sp3600") != -1)){//если в имени файла присувствует "SP3600" или "sp3600"
crum_SP3600 = 1;// то флаг crum_SP3600 установлен в 1
*crum = 12345678;
//выводим crum для Ricoh Sp3600 на дисплэй
          lcd.setCursor(0,0);
          lcd.print(CLEAN_TOTAL);
          lcd.setCursor(0,0);
          lcd.print(set_file);
          lcd.setCursor(0,1);
          lcd.print(CLEAN_TOTAL);
          lcd.setCursor(0,1);
          Serial.print(F("CRUM generator for SP3600 redy = "));
for(byte n = 0; n < 8; n++){
crum[n] = random(1, 256);//генерирует по 1 биту случайные числа в диапозоне от 1 до 255 включительно
lcd.print(crum[n], HEX);
Serial.print(crum[n], HEX );
Serial.print(F(" "));  
}
Serial.println();
          
          
          

}else{//иначе crum генератор для xer, sams




//=======создаем генератор случайных чисел, для генерации уникальных 11 значных CRUM - ов ================================
for(byte n = 0; n < 11; n++){//где n - это количесто цифор CRUM которые нужно сгенерировать       
   crum[n] = random(48, 58); //генерирует 1 случайную цифру в диапозоне от 48 до 58(DEC) = от 30 до 40(HEX) (не включительно)(цифры от 1 до 9 по таблице символов ANSI
}

Serial.print(F("CRUM generator redy = "));
Serial.println((char*)crum);
}
//=========================================================================================================================


//==============================================================================================================================
int addr = 0;
byte data; 
  File dataFile = SD.open("/" + name_folder + "/" + set_file);

if(algoritm == 0)dataFile.seek(152);//задаем смещение курсора в открытом файле .e2p, что бы исключить прошивку заголовка в eeprom
if(algoritm == 1)dataFile.seek(0);//для файлов .bin не существуют заголовки, по этому начинаем заливать в чип весь .bin файл
  if (dataFile && error == 0) {
    while (dataFile.available() && addr < value_EEPROM_Chip) {//заливаем прошивку с sd card пока не закончатся данные из файла прошивки
      data = byte(dataFile.read());
     if(algoritm == 0)addr = int((dataFile.position()) - 153);//здесь определяется позиция курсора в открытом файле .e2p и отнимается смещение заголовка, 
      //что бы адреса eeprom начинались с нулевого
     if(algoritm == 1)addr = int((dataFile.position()) - 1); //здесь определяется позция курсора в открытом файле .bin
      Serial.print(F("adres = "));
      Serial.print(addr);
      Serial.print(F(" 0x"));
      Serial.print(data, HEX);
      Serial.println();
      //lcd.setCursor(0,0);
      //lcd.print(CLEAN_TOTAL);
      lcd.setCursor(12,0);
      lcd.print(addr + 1);//выводим на дисплэй количество прошитых адресов (битов).
                      
       if(no_crum == 0 ){//если crum не найден       
      if(crum_SP3600 == 1 && addr >= 16 && addr <= 23){//если адрес равен 16(DEC) = 10(HEX) и CRUM для SP3600
        i = i + 1;// счетчик замененных битов серийника Ricoh SP3600
        
       eeprom.writeByte(addr, crum[i]); //то записываем побитово из crum генератора SP3600
       Serial.print(F("Crum SP3600 detect, podmena na: "));
       Serial.println(byte(crum[i]), HEX);
                      
      }else{
       eeprom.writeByte(addr, data); //то записываем данные из файла на SD card
       
     }
        delay(10);// пауза для записи в eeprom
       }
       
       if(no_crum == 1){//если crum найден xer & sams
      Serial.print(F("CRUM detect, podmena na 0x"));
      Serial.print(char(crum[i]), HEX);
      Serial.println();    
      eeprom.writeByte(addr, crum[i]);//то подменяем его на свой из *crum        
      delay(10);// пауза для записи в eeprom
      if(no_crum == 1 && (eeprom.readByte(addr) != crum[i])){//здесь проверяем то что мы записали в eeprom с тем что из *crum
            
      lcd.setCursor(0,0);
      lcd.print(CLEAN_TOTAL);
      lcd.setCursor(0,0);
      lcd.print(FILED);
      lcd.setCursor(0,1);
      lcd.print(CLEAN_TOTAL); 
      lcd.setCursor(4,1);
      lcd.print(ERROR_1);
      error = 1;      
     dataFile.close();  
     break;  
     }        
       }
             
      if(no_crum == 0){//здесь проверяем то что мы записали в eeprom с тем что из файла на sd card
      if(crum_SP3600 == 1 && addr >= 16 && addr <= 23){//если адрес равен 16(DEC) = 10(HEX) и CRUM для SP3600
      if(eeprom.readByte(addr) != crum[i]){ //то сравниваем по битово CRUM из чипа с i битом из генератора SP3600
       if(i == 8)i=0; 
      lcd.setCursor(0,0);
      lcd.print(CLEAN_TOTAL);
      lcd.setCursor(0,0);
      lcd.print(FILED);
      lcd.setCursor(0,1);
      lcd.print(CLEAN_TOTAL); 
      lcd.setCursor(4,1);
      lcd.print(ERROR_1);
      error = 1;      
     dataFile.close();  
     break;          
      }
      }
       
       
 else if(eeprom.readByte(addr) != data){
                
      lcd.setCursor(0,0);
      lcd.print(CLEAN_TOTAL);
      lcd.setCursor(0,0);
      lcd.print(FILED);
      lcd.setCursor(0,1);
      lcd.print(CLEAN_TOTAL); 
      lcd.setCursor(4,1);
      lcd.print(ERROR_1);
      error = 1;      
     dataFile.close();  
     break;  
     }
      }
      
       
    if(no_crum == 1){
     if(i < 11)i = i+1;
        if(i == 11){
          no_crum = 0;
          i = 0;
          //выводим crum на дисплэй
          lcd.setCursor(0,0);
          lcd.print(CLEAN_TOTAL);
          lcd.setCursor(0,0);
          lcd.print(set_file);
          lcd.setCursor(0,1);
          lcd.print(CLEAN_TOTAL);
          lcd.setCursor(0,1);
          lcd.print(CRUM);
          lcd.setCursor(5,1);
          lcd.print((char*)crum);          
        }
     }
//============== распознование CRUM - ов в файле прошивки прямо в потоке данных из файла в чип =================================     
      if(char(data) == '-' && search_crum == 5){ 
        search_crum = 1; 
        no_crum = 1;
               
      }else if(char(data) == 'M' || char(data) == 'm' && search_crum == 4){
        if(char(data) == 'M' || char(data) == 'm'){
          search_crum = 5; 
        }else{search_crum = 1;}
        
          }else if(char(data) == 'U' || char(data) == 'u' && search_crum == 3){
            if(char(data) == 'U' || char(data) == 'u'){
              search_crum = 4;
            }else{search_crum = 1;} 
            
            
               }else if(char(data) == 'R' || char(data) == 'r'|| char(data) == '-' && search_crum == 2){
                if(char(data) == 'R' || char(data) == 'r'){
                  search_crum = 3; 
                }
                if(char(data) == '-'){
                  search_crum = 1;
                  no_crum = 1;
                }else{search_crum = 1;}
                
                    }else if(char(data) == 'C'  || char(data) == 'k' || char(data) == 'K' || char(data) == 'c' || char(data) == 'y' || char(data) == 'Y' || char(data) == 'm' || char(data) == 'M' && search_crum == 1){
                      search_crum = 2;  
                         }else{//фикс 1
                          search_crum = 1;
                         }
//=========================================================================================================================================================================================================================     
    }
    dataFile.close();
    delay(100);
    if(error == 0){
      lcd.setCursor(0,0);
      lcd.print(CLEAN_TOTAL);
      lcd.setCursor(4,0);
      lcd.print(SUCCESS);
      lcd.setCursor(0,1);
      lcd.print(CLEAN_TOTAL); 
      lcd.setCursor(3,1);
      lcd.print(BACK);
    }    
  }
  
  
} 

//update_batt = millis();// сбрасывает таймер обновления батареи сразу же после прошивки, что бы не выбросило в меню (menu = 0) батареи 
error = 0;//сброс ошибок
menu = 2;  
}

void LCD_24cXX(){
  lcd.clear();
  lcd.setCursor(2,0);
  lcd.print(F("Chip Write"));
  lcd.setCursor(0,1);
  lcd.print(CLEAN_RIHGT);
  lcd.setCursor(4,1);
  lcd.print(F("Click Ok")); 
}

void value_EEPROM(){//функция определения объема/модели чипа 24сХХ
  
 Eeprom24C04_16 eeprom(i2c_adrr);
eeprom.initialize(); 
//======================== 1-ый алгоритм определения объема чипа 24сХХ===================================== 
 value_EEPROM_Chip = 0; 
for(int value_128 = 128; value_128 < 2048; value_128++){
 if(eeprom.readByte(value_128) > 0){//если обноружены данные отличные от нуля
  break;//то отмена сканирования чипа и объем не равен 128 битам  
 }
 if(value_128 == 2047)value_EEPROM_Chip = 128;//если сканирование дошло до конца и данных отличных от нуля небыло - обем равен 128 бит
}

if(value_EEPROM_Chip == 0){
 for(int value_256 = 256; value_256 < 2048; value_256++){
 if(eeprom.readByte(value_256) > 0){//если обноружены данные отличные от нуля
  break;//то отмена сканирования чипа и объем не равен 256 битам  
 }
 if(value_256 == 2047)value_EEPROM_Chip = 256;//если сканирование дошло до конца и данных отличных от нуля небыло - обем равен 256 бит
} 
}

if(value_EEPROM_Chip == 0){
 for(int value_512 = 512; value_512 < 2048; value_512++){
 if(eeprom.readByte(value_512) > 0){//если обноружены данные отличные от нуля
  break;//то отмена сканирования чипа и объем не равен 512 битам  
 }
 if(value_512 == 2047)value_EEPROM_Chip = 512;//если сканирование дошло до конца и данных отличных от нуля небыло - обем равен 512 бит
} 
}

if(value_EEPROM_Chip == 0){
 for(int value_1024 = 1024; value_1024 < 2048; value_1024++){
 if(eeprom.readByte(value_1024) > 0){//если обноружены данные отличные от нуля
  value_EEPROM_Chip = 2048;
  break;//то отмена сканирования чипа и объем не равен 1024 битам  
 }
 if(value_1024 == 2047)value_EEPROM_Chip = 1024;//если сканирование дошло до конца и данных отличных от нуля небыло - обем равен 1024 бит
} 
}
//=======================конец первого алгоритма ========================================================================================

//определяем является ли чип пустым
bool check_empty = 1;//если 0 то чип пуст, 1 - в чипе есть данные

for(int empty = 0; empty < value_EEPROM_Chip; empty++){
if(eeprom.readByte(empty) != 255){
  check_empty = 1;
  break;//если обнаружены данные, т.е. данные не равны 255 DEC (В пустых чипах все ячейки заполнены 255)  
}
if(empty == (value_EEPROM_Chip - 1))check_empty = 0;//если удалось просканировать чип полностью и все было заполненно 255, то чип пуст
}

if(check_empty == 1){ //если чип не пуст, то применяем 2-ой алгоритм распознования объема
byte bufer1[8];//буфер для хранения первых 8 - ми бит
byte bufer2[8];//буфер для проверки повторных масивов
Serial.println(F("check_empty = 1"));

  for(int i = 0; i < 8; i++){//
 bufer1[i] = eeprom.readByte(i); //заполняет первый буфер данными 
  }

int offset = 0;
int counts_byts_offset128 = 0;
int counts_byts_offset256 = 0;
int counts_byts_offset512 = 0;
int counts_byts_offset1024 = 0;


const int offset128 = 128;
const int offset256 = 256;
const int offset512 = 512;
const int offset1024 = 1024;
  
if(value_EEPROM_Chip == 256 ){  

for(int i = 0; i < 8; i++){
 if(eeprom.readByte(i + offset128) == bufer1[i])counts_byts_offset128 = counts_byts_offset128 + 1;
  
 }
 
 if(counts_byts_offset128 == 8  ){
value_EEPROM_Chip = 128; 
}

if(counts_byts_offset128 != 8 && counts_byts_offset256 != 8 ){
value_EEPROM_Chip = 256; 
}

}

if(value_EEPROM_Chip == 512 ){  

for(int i = 0; i < 8; i++){
 if(eeprom.readByte(i + offset128) == bufer1[i])counts_byts_offset128 = counts_byts_offset128 + 1;
 if(eeprom.readByte(i + offset256) == bufer1[i])counts_byts_offset256 = counts_byts_offset256 + 1;  
 }
 
 if(counts_byts_offset128 == 8 && counts_byts_offset256 == 8 ){
value_EEPROM_Chip = 128; 
}

if(counts_byts_offset128 != 8 && counts_byts_offset256 == 8 ){
value_EEPROM_Chip = 256; 
}

if(counts_byts_offset128 != 8 && counts_byts_offset256 != 8 ){
value_EEPROM_Chip = 512; 
}

}


if(value_EEPROM_Chip == 1024 ){  

for(int i = 0; i < 8; i++){
 if(eeprom.readByte(i + offset128) == bufer1[i])counts_byts_offset128 = counts_byts_offset128 + 1;
 if(eeprom.readByte(i + offset256) == bufer1[i])counts_byts_offset256 = counts_byts_offset256 + 1;
 if(eeprom.readByte(i + offset512) == bufer1[i])counts_byts_offset512 = counts_byts_offset512 + 1;
   
 }
 
 if(counts_byts_offset128 == 8 && counts_byts_offset256 == 8 && counts_byts_offset512 == 8 ){
value_EEPROM_Chip = 128; 
}

if(counts_byts_offset128 != 8 && counts_byts_offset256 == 8 && counts_byts_offset512 == 8 ){
value_EEPROM_Chip = 256; 
}

if(counts_byts_offset128 != 8 && counts_byts_offset256 != 8 && counts_byts_offset512 == 8 ){
value_EEPROM_Chip = 1024; 
}

if(counts_byts_offset128 != 8 && counts_byts_offset256 != 8 && counts_byts_offset512 != 8 ){
value_EEPROM_Chip = 1024; 
}
}


if(value_EEPROM_Chip == 2048){
    
for(int i = 0; i < 8; i++){
 if(eeprom.readByte(i + offset128) == bufer1[i])counts_byts_offset128 = counts_byts_offset128 + 1;
 if(eeprom.readByte(i + offset256) == bufer1[i])counts_byts_offset256 = counts_byts_offset256 + 1;
 if(eeprom.readByte(i + offset512) == bufer1[i])counts_byts_offset512 = counts_byts_offset512 + 1;
 if(eeprom.readByte(i + offset1024) == bufer1[i])counts_byts_offset1024 = counts_byts_offset1024 +1;  
 }
 Serial.print(F("counts_byts_offset128 "));
 Serial.println(counts_byts_offset128);

Serial.print(F("counts_byts_offset256 "));
 Serial.println(counts_byts_offset256);

  Serial.print(F("counts_byts_offset512 "));
 Serial.println(counts_byts_offset512);

 Serial.print(F("counts_byts_offset1024 "));
 Serial.println(counts_byts_offset1024);
 
 if(counts_byts_offset128 == 8 && counts_byts_offset256 == 8 && counts_byts_offset512 == 8 && counts_byts_offset1024 == 8){
value_EEPROM_Chip = 128; 
}

if(counts_byts_offset128 != 8 && counts_byts_offset256 == 8 && counts_byts_offset512 == 8 && counts_byts_offset1024 == 8){
value_EEPROM_Chip = 256; 
}

if(counts_byts_offset128 != 8 && counts_byts_offset256 != 8 && counts_byts_offset512 == 8 && counts_byts_offset1024 == 8){
value_EEPROM_Chip = 512; 
}

if(counts_byts_offset128 != 8 && counts_byts_offset256 != 8 && counts_byts_offset512 != 8 && counts_byts_offset1024 == 8){
value_EEPROM_Chip = 1024; 
}


if(counts_byts_offset128 != 8 && counts_byts_offset256 != 8 && counts_byts_offset512 != 8 && counts_byts_offset1024 != 8){
value_EEPROM_Chip = 2048; 
}

}


}

}

void read_damp(){
 i2c_scaner();
//===========================установка адреса i2c==================================
Eeprom24C04_16 eeprom(i2c_adrr);
eeprom.initialize();

//ниже идет выбор модели чипа на основании меню ==============================================
if(navigation == 1 && i2c_adrr != 0)value_EEPROM();//запуск функции авто определения объема/модели чипа 24сХХ
if(navigation == 2)value_EEPROM_Chip = 2048;//24с16
if(navigation == 3)value_EEPROM_Chip = 1024;//24с08
if(navigation == 4)value_EEPROM_Chip = 512;//24с04
if(navigation == 5)value_EEPROM_Chip = 256;//24с02
if(navigation == 6)value_EEPROM_Chip = 128;//24с01
//=============================================================================================

 File myFile;
if(i2c_adrr != 0){
lcd.clear();
lcd.setCursor(0, 0);
lcd.print(F("Read..."));

lcd.setCursor(10, 0);
if(value_EEPROM_Chip == 128){
  lcd.print(F("24C01"));  
}

if(value_EEPROM_Chip == 256){
  lcd.print(F("24C02"));  
}

if(value_EEPROM_Chip == 512){
  lcd.print(F("24C04"));  
}

if(value_EEPROM_Chip == 1024){
  lcd.print(F("24C08"));  
}

if(value_EEPROM_Chip == 2048){
  lcd.print(F("24C16"));  
}

//lcd.print(i2c_adrr);
//lcd.print(F("HEX"));
 //myFile = SD.open(F("/"));
  if(SD.exists(F("/damps")) == false){//проверка есть ли папка damps
   SD.mkdir(F("/damps")); //если нет то создать папку damps
   myFile = SD.open(F("/damps")); 
  }
  myFile.close();
  //SD.open(F("/damps"));
//определение имени нового файла дампа

  for(int n = 0; n < 100; n ++){
   set_file = "";
   set_file = F("damps/");
   set_file += String(n);
   set_file += F(".BIN");
   if(SD.exists(set_file) == false){//если такого номера файла не существует
   // SD.mkdir(set_file); //если нет то создать файл 
  myFile = SD.open(set_file, FILE_WRITE);//создает файл для записи
    break; 
   }
  }
  lcd.setCursor(0,1);
  lcd.print(set_file);
  
//================================================================================

for(int addr = 0; addr < value_EEPROM_Chip; addr++){//процес чтения из чипа в файл
  lcd.setCursor(12,1);
  lcd.print(F("    "));
  lcd.setCursor(12,1);
  lcd.print(addr + 1);
 byte data = eeprom.readByte(addr);

if(myFile){//если файл открыт
 myFile.write(data);//то записываем данные в файл 
 }
 
}

}
if(error == 0){
lcd.setCursor(10,0);
lcd.print(F("     "));  
lcd.setCursor(14,0);
lcd.print(F("OK"));
lcd.setCursor(12,1);
lcd.print(F("    "));
lcd.setCursor(12,1);
lcd.print(value_EEPROM_Chip);
}
error = 0;
myFile.close();
//update_batt = millis();// сбрасывает таймер обновления батареи сразу же после чтения дампа, что бы не выбросило в меню (menu = 0) батареи
}

void lcd_Read_damp(){
 lcd.clear();
 lcd.setCursor(0,0);
 lcd.print(F("Read damp 24CXX"));
 lcd.setCursor(0,1);
 lcd.print(LEFT_RIHGT);
 lcd.setCursor(5,1);
 lcd.print(F("Click Ok"));
  
}

void test_KX_MB1500(){
  int test_chip = A4;//DATA
  pinMode(test_chip, INPUT);
 if(analogRead(test_chip) < (bufer_KX_MB1500 - 30) || analogRead(test_chip) > (bufer_KX_MB1500 + 30)){
  bufer_KX_MB1500 = analogRead(test_chip);
  Serial.print(F("Value ACP kx-mb1500  "));
  Serial.println(bufer_KX_MB1500);
  if(analogRead(test_chip) < 10){
    lcd.setCursor(0, 1);
    lcd.print(CLEEN_LEFT);
    lcd.setCursor(3, 1);
    lcd.print(F("Chip NEW :)")); 
  }
  if(analogRead(test_chip) > 30 && analogRead(test_chip) < 100){
    lcd.setCursor(0, 1);
    lcd.print(CLEEN_LEFT);
    lcd.setCursor(3, 1);
    lcd.print(F("Chip OLD :(")); 
  }
if(analogRead(test_chip) > 900){
    lcd.setCursor(0, 1);
    lcd.print(CLEEN_LEFT);
    lcd.setCursor(1, 1);
    lcd.print(NO_CHIP); 
  }
//  update_batt = millis();// сбрасывает таймер обновления батареи, что бы не выбросило в меню (menu = 0) батареи 
 }
  
}

void lcd_set_chip_mod(){
  lcd.clear();
  lcd.setCursor(1,0);
  lcd.print(F("Set. mod. chip"));
  if(navigation == 1){
    lcd.setCursor(0,1);
    lcd.print(CLEAN_RIHGT);
    lcd.setCursor(5,1);
    lcd.print(F("AUTO"));    
  }
  
  if(navigation == 2){
    lcd.setCursor(0,1);
    lcd.print(LEFT_RIHGT);
    lcd.setCursor(1,1);
    lcd.print(F("24C16 (2048b)"));
  }

  if(navigation == 3){
    lcd.setCursor(0,1);
    lcd.print(LEFT_RIHGT);
    lcd.setCursor(1,1);
    lcd.print(F("24C08 (1024b)"));
  }

  if(navigation == 4){
    lcd.setCursor(0,1);
    lcd.print(LEFT_RIHGT);
    lcd.setCursor(1,1);
    lcd.print(F("24C04 (512b)"));
  }

  if(navigation == 5){
    lcd.setCursor(0,1);
    lcd.print(LEFT_RIHGT);
    lcd.setCursor(1,1);
    lcd.print(F("24C02 (256b)"));
  }

  if(navigation == 6){
    lcd.setCursor(0,1);
    lcd.print(CLEEN_LEFT);
    lcd.setCursor(1,1);
    lcd.print(F("24C01 (128b)"));
  }
  
}

void LCD_test_kx_mb1500(){
 lcd.clear();
lcd.setCursor(0, 0);
lcd.print(F("Test KX-MB1500"));
lcd.setCursor(0, 1);
lcd.print(LEFT_RIHGT); 
}

void chip_info(){
 i2c_scaner();
 //===========================установка адреса i2c==================================
Eeprom24C04_16 eeprom(i2c_adrr);
eeprom.initialize(); 
//=============================================================================
String bufer16bit = "";//создает и очищает буфер
if(i2c_adrr != 0){//если i2c адрес найден и чип тоже
  for(int b = 0; b < 16; b ++){
  bufer16bit += String(char(eeprom.readByte(b)));//заполняет буфер по 1 биту первыми 16-ю битами прочитанными из чипа (здесь содержится id модели)  
  }
//================================================================================
Serial.println(bufer16bit);
//==================================================================================

if(bufer16bit.lastIndexOf("XEROX") != -1){//id модели (данная функция не видит русских символов!)  
 Serial.println(F("Chip xer3119/120/220"));
 lcd.clear();
 lcd.setCursor(0, 0);
 lcd.print(F("xer3119/120/220."));
 lcd.setCursor(0, 1);
 
 if(eeprom.readByte(120) == 0){//читает данные по адресу 0х78(hex) = 120(DEC)для Ардуино все значения в DEC
  lcd.print(F("Toner OK"));// выводит метку тонера на дисплей
 }
 if(eeprom.readByte(120) == 1){//читает данные по адресу 0х78(hex) = 120(DEC)для Ардуино все значения в DEC
  lcd.print(F("Toner LOW"));// выводит метку тонера на дисплей
 }
 if(eeprom.readByte(120) == 2){//читает данные по адресу 0х78(hex) = 120(DEC)для Ардуино все значения в DEC
  lcd.print(F("NO toner"));// выводит метку тонера на дисплей
 }
 

 
}else if(bufer16bit.lastIndexOf("C4200") != -1){//  
 Serial.println(F("Chip SCX4200"));
 lcd.clear();
 lcd.setCursor(0, 0);
 lcd.print(F("Sams SCX-4200"));
 lcd.setCursor(0, 1);
 
 
 if(eeprom.readByte(120) == 0){//читает данные по адресу 0х78(hex) = 120(DEC)для Ардуино все значения в DEC
  lcd.print(F("Toner OK"));// выводит метку тонера на дисплей
 }
 if(eeprom.readByte(120) == 1){//читает данные по адресу 0х78(hex) = 120(DEC)для Ардуино все значения в DEC
  lcd.print(F("Toner LOW"));// выводит метку тонера на дисплей
 }
 if(eeprom.readByte(120) == 2){//читает данные по адресу 0х78(hex) = 120(DEC)для Ардуино все значения в DEC
  lcd.print(F("NO toner"));// выводит метку тонера на дисплей
 }
 
}


/*
 * здесь можете добавить др. идентификаторы моделей и выводимую для них информацию на дисплей
 * как в примерах выше
 */
else{
  Serial.println(F("Chip unknown"));
 lcd.clear();
 lcd.setCursor(0, 0);
 lcd.print(F("Chip unknown"));
 

}

}

}

void LCD_Chip_info(){
 lcd.clear();
 lcd.setCursor(3, 0);
 lcd.print(F("Chip info"));
 lcd.setCursor(0, 1);
 lcd.print(CLEEN_LEFT);
 lcd.setCursor(5, 1);
 lcd.print(F("Click Ok")); 
}


void loop() {
k=analogRead(key_in);
if(k < 1000 && key == 0){
   key = 1;  
  delay(20);
/*  
if(analogRead(key_in) < 1000){
  //key = 1;
  timer_out_power_off = millis();//сбрасывает таймер автовыключения питания при нажатии любой кнопки
  update_batt = millis();//сбрасывает таймер для обновления процентов батареии    
}
*/
if(((MENUKEY-10)<k)&&(k<(MENUKEY+10))) { //кнопка Chip info ("Select" на LCD Keypad Shield)
 menu = 7;
 navigation = 3;
 chip_info(); 
}

if(((RIGHTKEY-10)<k)&&(k<(RIGHTKEY+10))) {//кнопка вправо (analogRead(key_in) > 320 && analogRead(key_in) < 380)
Serial.println(F(">"));

if(menu == 1 && navigation == 2){
  navigation = 3;
  LCD_Chip_info();
}

if(menu == 1 && navigation == 1){
navigation = 2;
LCD_test_kx_mb1500();  
}


if(menu == 1 && navigation == 0){
 navigation = navigation + 1;
 lcd_Read_damp();
}

if(menu == 5 && navigation < 6){
navigation = navigation + 1;
lcd_set_chip_mod();  
}

if(navigation < counts_folder && menu == 2){
    navigation = navigation +1; 
    root = SD.open("/");  
    SD_card(root);  
    root.close();
}
if(navigation < counts_file_2 && menu == 3){
  navigation = navigation +1;
  root = SD.open(name_folder + "/");
  SD_card(root);
  root.close();
}
  
}

if(((OKKEY-10)<k)&&(k<(OKKEY+10))) {//кнопка Ок (DOWN на LCD Keypad Shield)
Serial.println(F("Ok"));
//key = 1;
if(menu == 1 && navigation == 3){
  menu = 7;
chip_info();  
}

if(menu == 3)menu = 4;
if(menu == 2)menu = menu + 1;

if(menu == 1 && navigation == 0){
menu = menu + 1;  
}

if(menu == 5){
 menu = 6;
 read_damp(); 
}

if(menu == 1 && navigation == 1){
//menu = 6;
menu = 5;
navigation = 1;

lcd_set_chip_mod();  
}


if(menu == 0){
  navigation = 0;
  LCD_24cXX();
  menu = menu + 1;
}







if(menu == 2){//выбор модели
  navigation = 1;
  root = SD.open("/");  
  SD_card(root);  
  root.close();
}
if(menu == 3){//выбор прошивки
  navigation = 1;
root = SD.open(name_folder + "/");
 SD_card(root);
 root.close();    
}

if(menu == 4){// процесс прошивки
program_Work();
}

Serial.print(F("menu = "));
Serial.println(menu);
}

if(((LEFTKEY-10)<k)&&(k<(LEFTKEY+10))) {//кнопка влево 
Serial.println(F("<"));
//key = 1;

if(menu == 1 && navigation == 1){
  LCD_24cXX();
navigation = navigation - 1;  
}

if(menu == 1 && navigation == 2){
 navigation = 1;
 lcd_Read_damp();
 bufer_KX_MB1500 = 0; 
}

if(menu == 1 && navigation == 3){
 navigation = 2;
 bufer_KX_MB1500 = 0;
 LCD_test_kx_mb1500(); 
}

if(menu == 5 && navigation > 1){
navigation = navigation - 1;
lcd_set_chip_mod();  
}

if(navigation != 0 && menu == 2){
  navigation = navigation - 1;
  root = SD.open("/");  
  SD_card(root);
  root.close();
}

if(navigation > 1 && menu == 3){
 navigation = navigation - 1;
 root = SD.open(name_folder + "/");
 SD_card(root);
 root.close(); 
}

  
}

if(((UPKEY-10)<k)&&(k<(UPKEY+10))) {//кнопка назад (up на LCD KeyPadShield)
Serial.println(F("back"));
//key = 1;

if(menu > 0 && menu < 5){
  navigation = 0;
  menu = menu - 1;
  
  LCD_24cXX();
}

if(menu == 2){
  navigation = 1;
 root = SD.open("/");  
    SD_card(root);  
    root.close(); 
}

if(menu == 5){
menu = 1;
navigation = 1;
lcd_Read_damp();  
}

if(menu == 6){
  menu = 5;
  navigation = 1;
  lcd_set_chip_mod();
}

if(menu == 2 ){
navigation = 0;
root = SD.open("/");
SD_card(root);
root.close();

}

if(menu == 7){
menu = 1;
navigation = 3;
LCD_Chip_info(); 
}
/*
if(menu == 0){
  batt();
}
*/

Serial.print(F("menu = "));
Serial.println(menu);
//Serial.println(utf8rus("назад"));  
}
Serial.print(F("navigation =  "));
Serial.println(navigation);
  
}

//=============================================================================
if(menu == 1 && navigation == 2)test_KX_MB1500();

if(analogRead(key_in) > 1000){
key = 0;
if(key == 0)timer_long_press_key = millis();  
}
if(millis() - timer_long_press_key > LONG_PRESS_KEY ){
  key = 0;
}
/*
if(millis() - timer_out_power_off > (AUTO_OFF * 60000)){//здесь тикакет таймер на автоотключение питания при бездействии
 digitalWrite(power, LOW); //выключаем питание 
}

if(millis() - update_batt > 20000){//обновляет показание заряда батареии каждых 20 сек
update_batt = millis();
if(menu != 0){
menu = 0;
}
batt();  
}
*/
}
